
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define WUSERHWDR 0
#define WDEPS1 1
#define USEREXTRA 2
#define DEPS3 3
#define WUSERHWDEF 4
#define WDEPS4 5
#define MAKEWPA 6
#define MAKELPA 7
#define ALL_EXE 8
#define WLINRAD_EXE 9
#define LLINRAD_EXE 10
#define WLINRADVC_EXE 11
#define LLINRADVC_EXE 12
#define PALINRAD_H 13
#define LUSERHWDR 14
#define LUSERHWDEF 15
#define DEPS2 16
#define WLINRADPA_EXE 17
#define LLINRADPA_EXE 18

#define NO_OF_REPLACE 19

char *input_string[NO_OF_REPLACE]={"@WUSERHWDR@",      //0
                                   "@WDEPS1@",         //1
                                   "@USEREXTRA@",      //2
                                   "@DEPS3@",          //3
                                   "@WUSERHWDEF@",     //4
                                   "@WDEPS4@",         //5
                                   "@MAKEWPA@",        //6
                                   "@MAKELPA@",        //7
                                   "@ALL_EXE@",        //8
                                   "@WLINRAD_EXE@",    //9
                                   "@LLINRAD_EXE@",    //10
                                   "@WLINRADVC_EXE@",  //11
                                   "@LLINRADVC_EXE@",  //12
                                   "@PALINRAD_H@",     //13
                                   "@LUSERHWDR@",      //14
                                   "@LUSERHWDEF@",     //15
                                   "@DEPS2@",          //16
                                   "@WLINRADPA_EXE@",  //17
                                   "@LLINRADPA_EXE@"}; //18

char *output_string[NO_OF_REPLACE];

void replace(char *s, int *len)
{
int i, j, k;
int m,l1,l2;
for(j=0; j<NO_OF_REPLACE; j++)
  {
  l1=strlen(input_string[j]);
  l2=strlen(output_string[j]);
printf("\n%s -> %s",input_string[j],output_string[j]);
  m=l1-l2;
  i=0;
nxt_i:;  
  while(i <= len[0] && s[i]!=input_string[j][0])i++;
  k=0;
  while( k+i <= len[0] && 
         s[i+k]==input_string[j][k] && 
         input_string[j][k] != 0)k++;
  if(input_string[j][k] == 0)
    {
    len[0]-=m;
    if(m>0)
      {
      k=i;
      while(k < len[0])
        {
        s[k]=s[k+m];
        k++;
        }
      }
    else
      {
      k=len[0];
      while(k > i)
        {
        k--;
        s[k]=s[k+m];
        }
      }
    k=0;  
    while(k<l2)
      {
      s[i]=output_string[j][k];
      i++;
      k++;
      }
    }
  else
    {
    i++;
    }
  if(i<len[0])goto nxt_i;  
  }  
}

int main(int argc, char *argv[])
{
FILE *file;
char *s;
int i, j;
(void) *argv;
(void) argc;
s=malloc(0x40000);
if(s == NULL)
  {
  printf("\nERROR: could not allocate memory");
  exit(0);
  } 
for(j=0; j<NO_OF_REPLACE; j++)
  {
  output_string[j]="";
  }
// Set up the strings we want to replace the input strings with.
file=fopen("wusers_hwaredriver.c","r");
if(file != NULL)
  {
  output_string[WUSERHWDR]="1";
  output_string[WDEPS1]="wusers_hwaredriver.c";
  fclose(file);
  }
file=fopen("users_extra.c","r");
if(file != NULL)
  {
  output_string[USEREXTRA]="1";
  output_string[DEPS3]="users_extra.c";
  fclose(file);
  }
file=fopen("wusers_hwaredef.h","r");
if(file != NULL)
  {
  output_string[WUSERHWDEF]="1";
  output_string[WDEPS4]="wusers_hwaredef.h";
  fclose(file);
  }
output_string[MAKEWPA]="0";
output_string[MAKELPA]="0"; 
output_string[WLINRAD_EXE]="linrad.exe";
output_string[LLINRAD_EXE]="for_linux";  
output_string[WLINRADVC_EXE]="linradvc.exe :";
output_string[WLINRADPA_EXE]="linradpa.exe :";
file=fopen("pa-linrad.h","r");
  {
  if(file != NULL)
    {
    fclose(file);
    file=fopen("pa-lir.lib","r");
    if(file != NULL)
      {
      fclose(file);
      file=fopen("pa-vclir.lib","r");
      if(file != NULL)
        {
        output_string[MAKEWPA]="1";  
        output_string[ALL_EXE]="linrad.exe linradpa.exe linradvc.exe";
        output_string[PALINRAD_H]="pa-linrad.h";
        }
      }
    }
  }      
// ***************************************************
file=fopen("conf.h.in","r");
if(file == NULL)
  {
  printf("Could not open file: conf.h.in\n");
  exit(0);
  }
j=0;
i=1;
while(i != 0 && j< 0x3ffff)
  {  
  i=fread(&s[j],1,1,file);
  j++;
  }
j--;  
printf("\nReading %d bytes from conf.h.in",j);
fclose(file);
replace(s, &j);
file=fopen("conf.h","w");
if(file == NULL)
  {
  printf("\nCould not open conf.h for write");
  exit(0);
  }
i=fwrite(s,j,1,file);
fclose(file);
printf("\n%d bytes written to conf.h",j);
if(i!=1)
  {
  printf("\nERROR Buffer only written in part");
  exit(0);
  }
// ***************************************************
file=fopen("Makefile.in","r");
if(file == NULL)
  {
  printf("\nCould not open file: Makefile.in\n");
  exit(0);
  }
j=0;
i=1;
while(i != 0 && j< 0x3ffff)
  {  
  i=fread(&s[j],1,1,file);
  j++;
  }
j--;  
printf("\nReading %d bytes from Makefile.in",j);
fclose(file);
replace(s, &j);
file=fopen("Makefile","w");
if(file == NULL)
  {
  printf("\nCould not open Makefile for write");
  exit(0);
  }
i=fwrite(s,j,1,file);
fclose(file);
printf("\n%d bytes written to Makefile",j);
if(i!=1)
  {
  printf("\nERROR Buffer only written in part");
  exit(0);
  }
   
return 0;  
}
